/***************************************************************************
                          attributedialog.h  -  description                              
                             -------------------                                         
    begin                : Sat Sep 11 1999                                           
    copyright            : (C) 1999 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef ATTRIBUTEDIALOG_H
#define ATTRIBUTEDIALOG_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qcombobox.h>
#include <qlabel.h>
//Generated area. DO NOT EDIT!!!(end)

#include "basedialog.h"
#include "mycheckbox.h"

/**
  *@author Henrik Stormer
  */

class AttributeDialog : public BaseDialog  {
   Q_OBJECT
public: 
	AttributeDialog(QWidget *parent=0, const char *name=0);
	~AttributeDialog();

public slots:

  void setReadUser(char Attrib) {_ReadUser->setChecked(Attrib);}
  void setWriteUser(char Attrib) {_WriteUser->setChecked(Attrib);}
  void setExecuteUser(char Attrib) {_ExecuteUser->setChecked(Attrib);}

  void setReadGroup(char Attrib) {_ReadGroup->setChecked(Attrib);}
  void setWriteGroup(char Attrib) {_WriteGroup->setChecked(Attrib);}
  void setExecuteGroup(char Attrib) {_ExecuteGroup->setChecked(Attrib);}

  void setReadOther(char Attrib) {_ReadOther->setChecked(Attrib);}
  void setWriteOther(char Attrib) {_WriteOther->setChecked(Attrib);}
  void setExecuteOther(char Attrib) {_ExecuteOther->setChecked(Attrib);}

  void setOwner(QString Owner, const QStrList& OwnerList, bool Enabled);
  void setGroup(QString Group, const QStrList& GroupList, bool Enabled);

  QString getOwner() {return _Owner->currentText();}
  QString getGroup() {return _Group->currentText();}

  char getReadUser() {return _ReadUser->getChecked();}
  char getWriteUser() {return _WriteUser->getChecked();}
  char getExecuteUser() {return _ExecuteUser->getChecked();}

  char getReadGroup() {return _ReadGroup->getChecked();}
  char getWriteGroup() {return _WriteGroup->getChecked();}
  char getExecuteGroup() {return _ExecuteGroup->getChecked();}

  char getReadOther() {return _ReadOther->getChecked();}
  char getWriteOther() {return _WriteOther->getChecked();}
  char getExecuteOther() {return _ExecuteOther->getChecked();}

protected:
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	QGroupBox *QGroupBox_2;
	QGroupBox *QGroupBox_1;
	QPushButton *_OK;
	QPushButton *_Cancel;
	QComboBox *_Owner;
	QComboBox *_Group;
	QLabel *QLabel_1;
	QLabel *QLabel_2;
	//Generated area. DO NOT EDIT!!!(end)
 	MyCheckBox *_ReadUser;
	MyCheckBox *_WriteUser;
	MyCheckBox *_ExecuteUser;
	MyCheckBox *_ReadGroup;
	MyCheckBox *_WriteGroup;
	MyCheckBox *_ExecuteGroup;
	MyCheckBox *_ReadOther;
	MyCheckBox *_WriteOther;
	MyCheckBox *_ExecuteOther;

private:
};

#endif















