/***************************************************************************
                          ftpextendeddialog.cpp  -  description
                             -------------------
    begin                : Tue Jan 4 2000
    copyright            : (C) 2000 by Henrik Stormer
    email                : stormer@ifi.unizh.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "ftpextendeddialog.h"
#include "ftppluginfactory.h"

const char* Columns[ColumnSize] = {"Empty", "Name", "Attribute", "Size", "Owner", "Group", "Date 1", "Date 2", "Date 3"};

FtpExtendedDialog::FtpExtendedDialog(QList<short> ColumnOrder) : BaseDialog()
{
	initDialog();
  QListIterator<short> it(ColumnOrder);
  for (;it.current();++it)
  {
    _RightBox->insertItem(Columns[*(it.current())]);
    if ((*it.current()) != Column_Empty)
    {
      unsigned int j;
      for (j=0;j<_LeftBox->count() && QString(_LeftBox->text(j)) != QString(Columns[*(it.current())]);j++) {}
      if (j < _LeftBox->count())
        _LeftBox->removeItem(j);
    }
  }

  connect(_Ok, SIGNAL(clicked()), SLOT(slotOk()));
  connect(_Cancel, SIGNAL(clicked()), SLOT(slotCancel()));
  connect(_Add, SIGNAL(clicked()), SLOT(slotAddClicked()));
  connect(_Remove, SIGNAL(clicked()), SLOT(slotRemoveClicked()));
}

FtpExtendedDialog::~FtpExtendedDialog()
{
}

void FtpExtendedDialog::slotAddClicked()
{
 int index;
 if ((index = _LeftBox->currentItem()) != -1)
 {
   _RightBox->insertItem(_LeftBox->text(index), _RightBox->currentItem()+1);
   if (QString(_LeftBox->text(index)) != Columns[Column_Empty])
    _LeftBox->removeItem(index);
 }
}

void FtpExtendedDialog::slotRemoveClicked()
{
 int index;
 if ((index = _RightBox->currentItem()) != -1)
 {
   if (QString(_RightBox->text(index)) != Columns[Column_Empty])
      _LeftBox->insertItem(_RightBox->text(index), _LeftBox->currentItem()+1);
   _RightBox->removeItem(index);
 }
}

short FtpExtendedDialog::findColumnIndex(QString text)
{
  for (int i=0;i<ColumnSize;i++)
  {
    if (Columns[i] == text) return i;
  }
  return -1;
}


void FtpExtendedDialog::getColumnList(QList<short>& ColumnOrder)
{
  ColumnOrder.clear();
  for (unsigned int i=0;i<_RightBox->count();i++)
  {
    short index = findColumnIndex (_RightBox->text(i));
    if (index != -1)
      ColumnOrder.append(new short(index));
  }
}