/***************************************************************************
                          ftppluginfactory.h  -  description                              
                             -------------------                                         
    begin                : Fri Dec 10 1999                                           
    copyright            : (C) 1999 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef FTPPLUGINFACTORY_H
#define FTPPLUGINFACTORY_H

#include "basepluginfactory.h"
#include "ftpplugin.h"
#include <qlist.h>

const short ColumnSize = 9;

const short Column_Empty = 0;
const short Column_Name = 1;
const short Column_Attrib = 2;
const short Column_Size = 3;
const short Column_Owner = 4;
const short Column_Group = 5;
const short Column_Date1 = 6;
const short Column_Date2 = 7;
const short Column_Date3 = 8;


class FtpConfiguration
{
  public:
   FtpConfiguration();
   FtpConfiguration(QString Name);
   FtpConfiguration(KConfig* Config, QString Name);
   QString _Name;
   QString _Host;
   QString _Dir;
   QString _User;
   QString _Password;
   int     _Port;
   bool    _Anonymous;
   QList<short> _ColumnOrder;
   bool readConfig(KConfig* Config, QString Name);
   bool writeConfig(KConfig* Config);
};

class QMultiLineEdit;
class KNCApp;
class FtpPluginFactory : public BasePluginFactory
{
 Q_OBJECT

  public:
   FtpPluginFactory(QMultiLineEdit* ProtocolView, KNCApp* App);
   virtual ~FtpPluginFactory();
 virtual bool isResponsible(QString Path, QString SubPath);
 virtual BasePlugin* generatePlugin(QString Dir, QString SubDir);

 void registerPlugin(FtpPlugin* Plugin) {_PluginList.append(Plugin);}
 void unregisterPlugin(FtpPlugin* Plugin) {_PluginList.remove(Plugin);}

 virtual bool addMenuItems(QPopupMenu*);
 virtual bool addToolbarItems(KToolBar*);
 virtual bool commandCallback(int id);
 virtual bool statusCallback(int id, QString& StatusMsg);
 virtual void initKeyAccel (KAccel*, KNCApp*);
 virtual void changeMenuAccel (KAccel*, QPopupMenu*);

 FtpConfiguration* getFtpConfiguration(QString Host);

 public slots:
  void slotFtpConnection();
  void slotFtpDisconnect();
 private:
  QMultiLineEdit*         _ProtocolView;
  QList<FtpConfiguration> _ConnectionList;
  QList<FtpPlugin>        _PluginList;
};

#endif=