/***************************************************************************
                          knc_plugins.cpp  -  description
                             -------------------
    begin                : Fri Nov 26 1999
    copyright            : (C) 1999 by Henrik Stormer
    email                : stormer@ifi.unizh.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
//this is the interface file for every plugin.


#include <knc.h>
#include <pluginadmin.h>


#include "tarfileplugin.h"
#include "generalfileplugin.h"
#include "ftppluginfactory.h"
#include "automountpluginfactory.h"


void KNCApp::initPlugins()
{
  PluginAdmin::instance().registerPluginFactory(new AutomountPluginFactory());
  PluginAdmin::instance().registerPluginFactory(new FtpPluginFactory(_ProtocolView, this));
  PluginAdmin::instance().registerPluginFactory(new TarFilePluginFactory());
  PluginAdmin::instance().registerPluginFactory(new GeneralFilePluginFactory());
}




