/***************************************************************************
                          mountdialog.cpp  -  description
                             -------------------
    begin                : Tue Nov 30 1999
    copyright            : (C) 1999 by Henrik Stormer
    email                : stormer@ifi.unizh.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "mountdialog.h"


MountDialog::MountDialog(QString Title, QDict<FStab>& MntData) : BaseDialog()
{
	initDialog();
  QDictIterator<FStab> it (MntData);
  for (;it.current();++it)
    _MountEntries->insertItem(it.current()->getFile());

  setCaption(Title);
  _Mount->setText(Title);
  connect(_MountEntries, SIGNAL(selected(int)), SLOT(slotSelected(int)));
  connect(_Mount, SIGNAL(clicked()), SLOT(slotOk()));
  connect(_Cancel, SIGNAL(clicked()), SLOT(slotCancel()));
  _MountEntries->setSelected(0,true);
  _MountEntries->setFocus();
}

MountDialog::~MountDialog()
{
}

QString MountDialog::getType()
{
 int index = _MountEntries->currentItem();
 if (index != -1) return _MountEntries->text(index);
 else return "";
}