/***************************************************************************
                          mountoptiontab.cpp  -  description
                             -------------------
    begin                : Tue Nov 30 1999
    copyright            : (C) 1999 by Henrik Stormer
    email                : stormer@ifi.unizh.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "mountoptiontab.h"
#include "qlistview.h"

MountOptionTab::MountOptionTab(QDict<FStab>& MountData) : BaseOptionTab(), _MountData(MountData)
{
	initDialog();
  QDictIterator<FStab> it (_MountData);
  for (;it.current();++it)
  {
    _MountList->insertItem(it.current()->getFile());
    _OldValues.insert(it.current()->getFile(), new bool (it.current()->getAutomount()));
  }

  connect(_MountList, SIGNAL(highlighted(const char*)), this, SLOT(slotSelected(const char*)));
  if (!_MountData.isEmpty()) _MountList->setSelected(0,true);
}

MountOptionTab::~MountOptionTab()
{
}

/*
 save the current entry in the reference.
*/
void MountOptionTab::okPressed()
{
  _FS->setAutomount(_Automount->isChecked());
}

/*
  Restore the old values if the user presses cancel. Remember, we
  are working on a reference.
*/
void MountOptionTab::cancelPressed()
{
  QDictIterator<bool> it (_OldValues);
  for (;it.current();++it)
  {
    _MountData[it.currentKey()]->setAutomount(*(it.current()));
  }
}
void MountOptionTab::slotSelected(const char* Selected)
{
  if (_FS)
  {
    _FS->setAutomount(_Automount->isChecked());
  }

  _FS = _MountData[Selected];
  if (_FS)
  {
    _Specification->setText(_FS->getSpec());
    _File->setText(_FS->getFile());
    _VFSType->setText(_FS->getVFSType());
    _MntOptions->setText(_FS->getMntOps());
    _Type->setText(_FS->getType());

    _Freq->setText(QString().setNum(_FS->getFreq()));
    _Passno->setText(QString().setNum(_FS->getPassno()));
    _Automount->setChecked(_FS->getAutomount());
  }
}
