/***************************************************************************
                          mycheckbox.h  -  description                              
                             -------------------                                         
    begin                : Sat Sep 11 1999                                           
    copyright            : (C) 1999 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef MYCHECKBOX_H
#define MYCHECKBOX_H


#include <qcheckbox.h>

/**
  *@author Henrik Stormer
  */

class MyCheckBox : public QCheckBox  {
   Q_OBJECT

 public:
	MyCheckBox(QWidget * parent=0, const char * name=0 );
	~MyCheckBox();

  bool isChecked() {return _State == 0;}
  bool isUnchecked() {return _State == 1;}
  bool isNoState() {return _State == 2;}
  char getChecked() {return _State;}

  void setChecked() {_State = 0;}
  void setUnchecked() {_State = 1;}
  void setNoState() {_State = 2;}
  void setChecked(char Setting) {_State = Setting;}

  void paintEvent( QPaintEvent *event );
  virtual void drawButton(QPainter *paint);
 public slots:
  void slotClicked();
 private:
  char _State;
};


#endif
