/***************************************************************************
                          mycolordialog.cpp  -  description
                             -------------------
    begin                : Wed Feb 16 2000
    copyright            : (C) 2000 by Henrik Stormer
    email                : stormer@ifi.unizh.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "mycolordialog.h"

MyColorDialog::MyColorDialog(QWidget *parent, const char *name) : BaseDialog(parent, name)
{
	initDialog();

  connect(_OK, SIGNAL(clicked()), SLOT(slotOk()));
  connect(_Cancel, SIGNAL(clicked()), SLOT(slotCancel()));
}

MyColorDialog::~MyColorDialog(){
}

bool MyColorDialog::getColor (QColor& ForegroundColor, QColor& BackgroundColor, QColor& FocusColor, QColor& FocusCursorColor)
{
  _ForegroundColor->setColor(ForegroundColor);
  _BackgroundColor->setColor(BackgroundColor);
  _FocusColor->setColor(FocusColor);
  _FocusCursorColor->setColor(FocusCursorColor);

  if (exec())
  {
    ForegroundColor = _ForegroundColor->color();
    BackgroundColor = _BackgroundColor->color();
    FocusColor = _FocusColor->color();
    FocusCursorColor = _FocusCursorColor->color();
    return true;
  }
  return false;
}