/***************************************************************************
                          pluginadmin.h  -  description                              
                             -------------------                                         
    begin                : Wed Oct 13 1999                                           
    copyright            : (C) 1999 by Henrik Stormer                         
    email                : stormer@ifi.unizh.ch                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef PLUGINADMIN_H
#define PLUGINADMIN_H

#include <baseplugin.h>
#include <qlist.h>
#include <knc.h>

typedef QList<BasePlugin>         PluginList;
typedef QListIterator<BasePlugin> PluginIterator;

typedef QList<BasePluginFactory>         PluginFactoryList;
typedef QListIterator<BasePluginFactory> PluginFactoryIterator;

/**
  *@author Henrik Stormer
*/

class PluginAdmin
{
 //the KNC Application needs to delete this class at the end;
 friend KNCApp;
public: 

  void        registerPluginFactory(BasePluginFactory* NewPlugin) {_PluginFactoryList.append(NewPlugin);}
  void        unregisterPlugin(BasePlugin* NewPlugin);

  BasePlugin* getResponsiblePlugin(QString Path, QString DownPath);
  BasePlugin* getResponsiblePluginInstance(QString Path, QString DownPath);

  PluginIterator        getPluginIterator()        {return PluginIterator(_PluginList);}
  PluginFactoryIterator getPluginFactoryIterator() {return PluginFactoryIterator(_PluginFactoryList);}

  void        addPluginInstance(BasePlugin* NewPlugin) {_PluginList.append(NewPlugin);}

  static PluginAdmin& instance() {if (!_instance) _instance = new PluginAdmin(); return *_instance;}

 protected:
	PluginAdmin();
	~PluginAdmin();

 private:
  static PluginAdmin* _instance;
  PluginFactoryList   _PluginFactoryList;
  PluginList          _PluginList;
};

#endif















